"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PerformanceHelper = void 0;
class Helper {
    constructor() {
        this.enabled = true;
        this.toSnakeCase = (str) => {
            const string = str
                .replace(/[A-Z]/g, (letter) => `_${letter.toLowerCase()}`)
                .replace(/^_/, '');
            if (string.match(/__/g)) {
                return string
                    .split('__')
                    .map((it) => it.replace(/_/g, ''))
                    .join('_');
            }
            return string;
        };
        this.sanitizeName = (name, limit) => {
            return this.toSnakeCase(name)
                .replace(/^\s+|\s+$/g, '')
                .replace(/\s/, '_')
                .substring(0, limit);
        };
        this.setGlobalDisabled = () => {
            this.enabled = false;
        };
        this.setGlobalEnabled = () => {
            this.enabled = true;
        };
        this.isGlobalEnabled = () => {
            return this.enabled;
        };
    }
}
exports.PerformanceHelper = new Helper();
//# sourceMappingURL=helpers.js.map